<?php

declare(strict_types=1);

namespace App\Repository;

final class TblNotificacionCMSRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblNotificacionCMSId): object
    {
        $query = 'SELECT * FROM `TblNotificacionCMS` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblNotificacionCMSId);
        $statement->execute();
        $TblNotificacionCMS = $statement->fetchObject();
        if (! $TblNotificacionCMS) {
            throw new \Exception('TblNotificacionCMS not found.', 404);
        }

        return $TblNotificacionCMS;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblNotificacionCMS` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblNotificacionCMS): object
    {
        $query = 'INSERT INTO `TblNotificacionCMS` (`Nombre`, `Descripcion`, `FechaEnvio`, `FechaFinalizaNotificacion`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:Nombre, :Descripcion, :FechaEnvio, :FechaFinalizaNotificacion, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblNotificacionCMS->id);
//         $statement->bindParam('fecha', $TblNotificacionCMS->fecha);
        $statement->bindParam('Nombre', $TblNotificacionCMS->Nombre);
        $statement->bindParam('Descripcion', $TblNotificacionCMS->Descripcion);
        $statement->bindParam('FechaEnvio', $TblNotificacionCMS->FechaEnvio);
        $statement->bindParam('FechaFinalizaNotificacion', $TblNotificacionCMS->FechaFinalizaNotificacion);
        $statement->bindParam('field1', $TblNotificacionCMS->field1);
        $statement->bindParam('field2', $TblNotificacionCMS->field2);
        $statement->bindParam('field3', $TblNotificacionCMS->field3);
        $statement->bindParam('field4', $TblNotificacionCMS->field4);
        $statement->bindParam('field5', $TblNotificacionCMS->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblNotificacionCMS, object $data): object
    {
        if (isset($data->fecha)) {
            $TblNotificacionCMS->fecha = $data->fecha;
        }
        if (isset($data->Nombre)) {
            $TblNotificacionCMS->Nombre = $data->Nombre;
        }
        if (isset($data->Descripcion)) {
            $TblNotificacionCMS->Descripcion = $data->Descripcion;
        }
        if (isset($data->FechaEnvio)) {
            $TblNotificacionCMS->FechaEnvio = $data->FechaEnvio;
        }
        if (isset($data->FechaFinalizaNotificacion)) {
            $TblNotificacionCMS->FechaFinalizaNotificacion = $data->FechaFinalizaNotificacion;
        }
        if (isset($data->field1)) {
            $TblNotificacionCMS->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblNotificacionCMS->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblNotificacionCMS->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblNotificacionCMS->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblNotificacionCMS->field5 = $data->field5;
        }

        $query = 'UPDATE `TblNotificacionCMS` SET `fecha` = :fecha, `Nombre` = :Nombre, `Descripcion` = :Descripcion, `FechaEnvio` = :FechaEnvio, `FechaFinalizaNotificacion` = :FechaFinalizaNotificacion, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblNotificacionCMS->id);
        $statement->bindParam('fecha', $TblNotificacionCMS->fecha);
        $statement->bindParam('Nombre', $TblNotificacionCMS->Nombre);
        $statement->bindParam('Descripcion', $TblNotificacionCMS->Descripcion);
        $statement->bindParam('FechaEnvio', $TblNotificacionCMS->FechaEnvio);
        $statement->bindParam('FechaFinalizaNotificacion', $TblNotificacionCMS->FechaFinalizaNotificacion);
        $statement->bindParam('field1', $TblNotificacionCMS->field1);
        $statement->bindParam('field2', $TblNotificacionCMS->field2);
        $statement->bindParam('field3', $TblNotificacionCMS->field3);
        $statement->bindParam('field4', $TblNotificacionCMS->field4);
        $statement->bindParam('field5', $TblNotificacionCMS->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblNotificacionCMS->id);
    }

    public function delete(int $TblNotificacionCMSId): void
    {
        $query = 'DELETE FROM `TblNotificacionCMS` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblNotificacionCMSId);
        $statement->execute();
    }
}
